Leetcode494. Target Sum
题目:
You are given a list of non-negative integers, a1, a2, ..., an, and a target, S. Now you have 2 symbols +
and -
. For each integer, you should choose one from +
and -
as its new symbol.
Find out how many ways to assign symbols to make sum of integers equal to target S.
Example 1:
Input: nums is [1, 1, 1, 1, 1], S is 3. Output: 5 Explanation: -1+1+1+1+1 = 3 +1-1+1+1+1 = 3 +1+1-1+1+1 = 3 +1+1+1-1+1 = 3 +1+1+1+1-1 = 3 There are 5 ways to assign symbols to make the sum of nums be target 3.
Note:
- The length of the given array is positive and will not exceed 20.
- The sum of elements in the given array will not exceed 1000.
- Your output answer is guaranteed to be fitted in a 32-bit integer.
题目分析:这是一道动态规划的题目,但是由于我想不出动态规划的的算法,所以只好用dfs的方法来计算,主要是类似背包问题的dfs算法,取+-两种情况分析,列出函数。
void dfs(vector<int>& nums, int S, int length, int sum) {
if (length == nums.size()) {
if (sum == S) size++;
return;
}
dfs(nums, S, length+1, sum+nums[length]);
dfs(nums, S, length+1, sum-nums[length]);
}
代码:
class Solution {
public:
int size = 0;
int findTargetSumWays(vector<int>& nums, int S) {
dfs(nums,S,0,0);
return size;
}
void dfs(vector<int>& nums, int S, int length, int sum) {
if (length == nums.size()) {
if (sum == S) size++;
return;
}
dfs(nums, S, length+1, sum+nums[length]);
dfs(nums, S, length+1, sum-nums[length]);
}
};